=begin
#ChannelShipper & Royal Mail Public API

#Import your orders, retrieve your orders and generate labels.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module RoyalMail
  class CreateManifestsRequest
    # Can be specified together with <b>orderReferences</b>  in the same call, but cannot be mixed with other parameter types 
    attr_accessor :order_identifiers

    # Can be specified together with <b>orderIdentifiers</b> in the same call, but cannot be mixed with other parameter types 
    attr_accessor :order_references

    # Date and time in UTC. Used together with <b>endDateTime</b> to manifest all orders in an eligible state in a date/time range. If an <b>endDateTime</b> is specified without this parameter the start of the date/time range will be the earliest possible order. Cannot be mixed with other parameter types. 
    attr_accessor :start_date_time

    # Date and time in UTC. Used together with <b>startDateTime</b> to manifest all orders in an eligible state in a date/time range. If a <b>startDateTime</b> is specified without this parameter the end of the date/time range will be the latest possible order. Cannot be mixed with other parameter types. 
    attr_accessor :end_date_time

    # Cannot be mixed with other parameter types.
    attr_accessor :account_batch_numbers

    # Set to <code>true</code> and leave all the other parameters empty to manifest all orders in an eligible state up to and including the current day (orders with a future despatch date will not be included). Do not specify this parameter or alternatively set to <code>false</code> if specifying any other parameter options. 
    attr_accessor :all_orders

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'order_identifiers' => :'orderIdentifiers',
        :'order_references' => :'orderReferences',
        :'start_date_time' => :'startDateTime',
        :'end_date_time' => :'endDateTime',
        :'account_batch_numbers' => :'accountBatchNumbers',
        :'all_orders' => :'allOrders'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'order_identifiers' => :'Object',
        :'order_references' => :'Object',
        :'start_date_time' => :'Object',
        :'end_date_time' => :'Object',
        :'account_batch_numbers' => :'Object',
        :'all_orders' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `RoyalMail::CreateManifestsRequest` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `RoyalMail::CreateManifestsRequest`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'order_identifiers')
        if (value = attributes[:'order_identifiers']).is_a?(Array)
          self.order_identifiers = value
        end
      end

      if attributes.key?(:'order_references')
        if (value = attributes[:'order_references']).is_a?(Array)
          self.order_references = value
        end
      end

      if attributes.key?(:'start_date_time')
        self.start_date_time = attributes[:'start_date_time']
      end

      if attributes.key?(:'end_date_time')
        self.end_date_time = attributes[:'end_date_time']
      end

      if attributes.key?(:'account_batch_numbers')
        if (value = attributes[:'account_batch_numbers']).is_a?(Array)
          self.account_batch_numbers = value
        end
      end

      if attributes.key?(:'all_orders')
        self.all_orders = attributes[:'all_orders']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          order_identifiers == o.order_identifiers &&
          order_references == o.order_references &&
          start_date_time == o.start_date_time &&
          end_date_time == o.end_date_time &&
          account_batch_numbers == o.account_batch_numbers &&
          all_orders == o.all_orders
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [order_identifiers, order_references, start_date_time, end_date_time, account_batch_numbers, all_orders].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        RoyalMail.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
